<?php
return  array(
    'columns'=>array(
        'id' => array(
            'type' => 'number',
            'autoincrement' => true,
            //'pkey' => true,
            'required' => true,
            'comment' => app::get('sysclearing')->_('settlement_detail_id'),
        ),
        'oid'=>array(
            //'type'=>'bigint unsigned',
            'type' => 'bigint',
            'unsigned' => true,

            'required' => true,
            'comment' => app::get('sysclearing')->_('子订单编号'),
            'label' => app::get('sysclearing')->_('子订单编号'),
        ),
        'tid' => array(
            'type' => 'table:trade@systrade',
            'required' => true,
            'comment' => app::get('sysclearing')->_('订单编号'),
            'label' => app::get('sysclearing')->_('订单编号'),
            'in_list' => true,
            'default_in_list'=>true,
        ),
        'shop_id' => array(
            'type' => 'table:shop@sysshop',
            'required' => true,
            'comment' => app::get('sysclearing')->_('所属商家'),
            'label' => app::get('sysclearing')->_('所属商家'),
            'in_list' => true,
            'default_in_list'=>true,
        ),
        'settlement_time' => array(
            'type' => 'time',
            'label' => app::get('sysclearing')->_('可结算时间'),
            'in_list' => true,
            'default_in_list'=>true,
        ),
        'pay_time' => array(
            'type' => 'time',
            'label' => app::get('sysclearing')->_('付款时间'),
            'in_list' => true,
            'default_in_list'=>true,
        ),
        'item_id' => array(
            'type' => 'table:item@sysitem',
            'required' => true,
            'comment' => app::get('sysclearing')->_('商品id'),
            'label' => app::get('sysclearing')->_('商品id'),
            'in_list' => true,
            'default_in_list'=>true,
        ),
        'sku_id' => array(
            'type' => 'table:sku@sysitem',
            'required' => true,
            'comment' => app::get('sysclearing')->_('货品id'),
            'label' => app::get('sysclearing')->_('货品id'),
        ),
        'bn' => array(
            //'type'=>'varchar(45)',
            'type' => 'string',
            'length' => 45,
            'editable' => false,
            'is_title' => true,
            'comment' => app::get('sysclearing')->_('明细商品的编码'),
            'label' => app::get('sysclearing')->_('明细商品的编码'),
            'in_list' => true,
            'default_in_list'=>true,
        ),
        'title' => array(
            //'type' => 'varchar(60)',
            'type' => 'string',
            'length' => 90,
            'required' => true,
            'default' => '',
            'comment' => app::get('sysclearing')->_('商品标题'),
            'label' => app::get('sysclearing')->_('商品标题'),
            'in_list' => true,
            'default_in_list'=>true,
        ),
        'spec_nature_info' => array (
            'type' => 'text',
            'comment' => app::get('sysclearing')->_('sku描述'),
            'label' => app::get('sysclearing')->_('sku描述'),
        ),
        'price' => array(
            'type' => 'money',
            'comment' => app::get('sysclearing')->_('商品价格'),
            'label' => app::get('sysclearing')->_('商品价格'),
            'in_list' => true,
            'default_in_list'=>true,
        ),
        'num' => array(
            'type' => 'number',
            'comment' => app::get('sysclearing')->_('购买数量'),
            'label' => app::get('sysclearing')->_('购买数量'),
            'in_list' => true,
            'default_in_list'=>true,
        ),
        'sku_properties_name' => array(
            //'type' => 'varchar(500)',
            'type' => 'string',
            'length' => 500,
            'comment' => app::get('sysclearing')->_('SKU的值'),
            'label' => app::get('sysclearing')->_('SKU的值'),
        ),
        'divide_order_fee' => array(
            'type' => 'money',
            'comment' => app::get('sysclearing')->_('分摊之后的实付金额'),
            'label' => app::get('sysclearing')->_('分摊之后的实付金额'),
            'in_list' => true,
            'default_in_list'=>true,
        ),
        'part_mjz_discount' => array(
            'type' => 'money',
            'comment' => app::get('sysclearing')->_('优惠分摊'),
            'label' => app::get('sysclearing')->_('优惠分摊'),
            'in_list' => true,
            'default_in_list'=>true,
        ),
        'payment' => array(
            'type' => 'money',
            'comment' => app::get('sysclearing')->_('实付金额'),
            'label' => app::get('sysclearing')->_('实付金额'),
            'in_list' => true,
            'default_in_list'=>true,
        ),
        'post_fee' => array(
            'type'=>'money',
            'label' => app::get('sysclearing')->_('运费'),
            'required' => true,
            'is_title' => true,
            'in_list' => true,
            'default_in_list'=>true,
        ),
        'refund_fee' => array(
            'type' => 'money',
            'label' => app::get('sysclearing')->_('退款金额'),
            'in_list' => true,
            'default_in_list'=>true,
        ),
        'cat_service_rate' => array(
          'type' => 'money',
          'default' => '0',
          'label' => app::get('sysclearing')->_('佣金比例'),
          'width' => 75,
          'in_list' => true,
        ),
        'commission_fee' => array(
            'type' => 'money',
            'label' => app::get('sysclearing')->_('佣金'),
            'in_list' => true,
            'default_in_list'=>true,
        ),
        'settlement_fee' => array(
            'type' => 'money',
            'label' => app::get('sysclearing')->_('结算金额'),
            'in_list' => true,
            'default_in_list'=>true,
        ),
        'settlement_type' => array(
            'type' => array(
                '1'=>'普通结算',
                '2'=>'运费结算',
                '3'=>'售后结算',
                '4'=>'拒收结算',
            ),
            'default'=>'1',
            'label' => app::get('sysclearing')->_('结算类型'),
            'in_list' => true,
            'default_in_list'=>true,
        ),
        'discount_fee' => array(
            'type' => 'money',
            'comment' => app::get('sysclearing')->_('子订单级订单优惠金额'),
            'label' => app::get('sysclearing')->_('子订单级订单优惠金额'),
            'in_list' => true,
            'default_in_list'=>true,
        ),
        'adjust_fee' => array(
            'type' => 'money',
            'comment' => app::get('sysclearing')->_('手工调整金额'),
            'label' => app::get('sysclearing')->_('手工调整金额'),
            //'in_list' => true,
            //'default_in_list'=>true,
        ),
    ),
    'primary' => 'id',
    'comment' => app::get('sysclearing')->_('结算明细表'),
);
